package local.dev.blog.jUnitExample;
import org.apache.camel.component.mock.MockEndpoint;
import org.apache.camel.test.spring.CamelSpringTestSupport;
import org.junit.Test;
import org.springframework.context.support.ClassPathXmlApplicationContext;


public class CamelContextXmlTest extends CamelSpringTestSupport {

	final static String fileUK = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><person user=\"james\">  <firstName>James</firstName>  <lastName>Strachan</lastName>  <city>London</city></person>";
	final static String fileOther = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><person user=\"hiram\">  <firstName>Hiram</firstName>  <lastName>Chirino</lastName>  <city>Tampa</city></person>";
	
	@Test
	public void testUKFileHandling() throws Exception {

		MockEndpoint fileUKEndpoint = getMockEndpoint("mock:fileUK");		
		fileUKEndpoint.expectedBodiesReceived(fileUK);
		
		template.sendBody("direct:files", fileUK);
		
		assertMockEndpointsSatisfied();
	}
	
	@Test
	public void testOtherFileHandling() throws Exception {

		MockEndpoint fileUKEndpoint = getMockEndpoint("mock:fileOther");		
		fileUKEndpoint.expectedBodiesReceived(fileOther);
		
		template.sendBody("direct:files", fileOther);
		
		assertMockEndpointsSatisfied();
	}
	
	@Override
	protected ClassPathXmlApplicationContext createApplicationContext() {
		return new ClassPathXmlApplicationContext(
				"META-INF/spring/camel-context.xml",
				"UnitTestPropertiesOverride.xml");
	}

}
